<script setup lang="ts">
import { onMounted, ref } from 'vue'
import { useStockStore } from '@/stores/stock'
import { useRoute } from 'vue-router'
import { useOrderStore } from '@/stores/order'
import OrderDialogView from './OrderDialogView.vue'
import type { Material } from '@/types/Material'
import { useTypeStore } from '@/stores/type'

const headers = [
  {
    title: 'Id',
    key: 'id'
  },
  {
    title: 'Name',
    key: 'name'
  },
  {
    title: 'Price',
    key: 'price'
  },
  {
    title: 'Unit',
    key: 'unit'
  },
  {
    title: 'Minimum',
    key: 'minimum'
  },
  {
    title: 'Types',
    key: 'types',
    value: (item: any | Material) => item.type?.name
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

const route = useRoute()
const stockStore = useStockStore()
const materialTypeStore = useTypeStore()
const orderStore = useOrderStore()
const search = ref('')

onMounted(async () => {
  await stockStore.getMaterials()
  await materialTypeStore.getTypes()
})
</script>
<template>
  <!-- <NavigationDrawer></NavigationDrawer> -->
  <v-toolbar flat color="#212121">
    <v-toolbar-title>Order Stock</v-toolbar-title>
    <v-spacer></v-spacer>
    <v-text-field
      v-model="search"
      prepend-inner-icon="mdi-magnify"
      density="compact"
      label="Search"
      single-line
      flat
      hide-details
      variant="solo-filled"
      style="width: 1px"
    ></v-text-field>

    <!-- Put Dialog -->
    <v-menu transition="slide-y-transition">
      <template v-slot:activator="{ props }">
        <v-btn v-bind="props" icon>
          <v-icon>mdi-dots-vertical</v-icon>
        </v-btn>
      </template>
      <v-list>
        <v-list-item>
          <v-list-item-title>
            <v-btn
              block
              active-color="deep-orange-darken-4"
              link
              title="Stock"
              :class="{ active: route.name === 'stock' }"
              :to="{ path: '/Stock' }"
              rounded="0"
              elevation="0"
              style="display: flex; justify-content: flex-start; align-items: left;"
              >
              <v-icon size="25">mdi-package-variant-closed</v-icon>
              Stock
            </v-btn>
          </v-list-item-title>
          <v-list-item-title>
            <v-btn
              active-color="deep-orange-darken-4"
              link
              title="CheckStock"
              :class="{ active: route.name === 'checkstock' }"
              :to="{ path: '/CheckStock' }"
              rounded="0"
              elevation="0"
              block
              style="display: flex; justify-content: flex-start; align-items: left;"
              >
              <v-icon size="25">mdi-package-check</v-icon>
              CheckStock
            </v-btn>
          </v-list-item-title>
          <v-list-item-title>
            <v-btn
              active-color="deep-orange-darken-4"
              link
              title="HistoryStock"
              :class="{ active: route.name === 'history' }"
              :to="{ path: '/History' }"
              rounded="0"
              elevation="0"
              block
              style="display: flex; justify-content: flex-start; align-items: left;"
              >
              <v-icon size="25">mdi-history</v-icon>
              HistoryStock
            </v-btn>
          </v-list-item-title>
        </v-list-item>
      </v-list>
    </v-menu>
  </v-toolbar>
  <div>
    <v-data-table v-model:search="search" :headers="headers" :items="stockStore.materials">
      <template v-slot:top> </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-btn
          icon="mdi-cart"
          density="compact"
          size="small"
          @click="orderStore.addOrderReceipt(item)"
        ></v-btn>
      </template>
    </v-data-table>
  </div>
  <OrderDialogView></OrderDialogView>
  <v-row>
    <v-col></v-col>
    <v-col></v-col>
    <v-col></v-col>
    <v-col></v-col>
      <v-btn
          @click="orderStore.openDialog()"
          elevation="2"
          style="background-color: #c7a17a; margin-right: 15px; color: white">
          Order
          <v-card
            v-if="orderStore.orderItems.length > 0"
            color="#ed2939"
            style="
              border-radius: 50%;
              width: 20px;
              height: 20px;
              display: flex;
              align-items: center;
              justify-content: center;
            "
          >
            {{ orderStore.orderItems.length }}
          </v-card>
        </v-btn>
      <v-col></v-col>
      <v-col></v-col>
      <v-col></v-col>
      <v-col></v-col>
    </v-row>
</template>
<style scoped></style>
